get-aws-login 4.6 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191
  1. #!/usr/bin/env bash
  2. function log {
  3. if [ -t 1 ]; then
  4. echo "$@" >&2
  5. fi
  6. }
  7. # ignore existing credentials
  8. unset AWS_ACCESS_KEY_ID AWS_SECRET_ACCESS_KEY AWS_SESSION_TOKEN
  9. output="eval"
  10. duration=900
  11. use_cache=1
  12. eval set -- "$(getopt -o p:d:o: --long profile:,duration:,output: -- "$@")"
  13. while true; do
  14. case "$1" in
  15. -p|--profile)
  16. profile=$2
  17. shift 2
  18. ;;
  19. -d|--duration)
  20. if [ -n "$2" ]; then
  21. duration=$2
  22. use_cache=0
  23. fi
  24. shift 2
  25. ;;
  26. -o|--output)
  27. if [ -n "$2" ]; then
  28. output=$2
  29. fi
  30. shift 2
  31. ;;
  32. --)
  33. shift
  34. break
  35. ;;
  36. *)
  37. echo "Internal error!"
  38. exit 1
  39. esac
  40. done
  41. cache_key="aws-$profile"
  42. cache_gpg="$XDG_RUNTIME_DIR/$cache_key.gpg"
  43. function get_from_keepassxc {
  44. keepassxc-cli show -q "$KEEPASS_FILE" "$KEEPASS_AWS_ENTRY" -a "$1" <<< "$2"
  45. }
  46. function get_role_arn {
  47. if ! aws configure get "profile.$profile.source_role_arn"; then
  48. log "source_role_arn not set for profile $profile"
  49. log "run aws configure set profile.$profile.source_role_arn <role arn>"
  50. return 1
  51. fi
  52. }
  53. function get_cached_long_term_credentials {
  54. if [ ! -f "$cache_gpg" ]; then
  55. log "No cached long-term credentials, requesting new"
  56. return 1
  57. fi
  58. if ! cached=$(gpg --batch -d --passphrase-file <(echo "$password") "$cache_gpg" 2>/dev/null); then
  59. log "Error getting cached long-term credentials"
  60. return 2
  61. fi
  62. expiration=$(date -d "$(jq -r '.Credentials.Expiration' <<< "$cached")" +%s)
  63. if [ "$expiration" -lt "$(date +%s)" ]; then
  64. log "Cached long-term credentials expired, requesting new"
  65. return 1
  66. fi
  67. echo "$cached"
  68. }
  69. function get_long_term_credentials {
  70. local duration
  71. local password
  72. duration="$1"
  73. if ! password=$(zenity --password --timeout=60 2> /dev/null); then
  74. log "Failed to get password"
  75. return 1
  76. fi
  77. credentials=$(get_cached_long_term_credentials)
  78. retcode=$?
  79. if [ $retcode -eq 2 ]; then
  80. exit 1
  81. elif [ $retcode -eq 1 ]; then
  82. if ! role_arn=$(get_role_arn); then
  83. return 1
  84. fi
  85. if ! AWS_ACCESS_KEY_ID=$(get_from_keepassxc UserName "$password"); then
  86. log "Failed to open vault"
  87. exit 1
  88. fi
  89. if ! AWS_SECRET_ACCESS_KEY=$(get_from_keepassxc Password "$password"); then
  90. log "Failed to open vault"
  91. exit 1
  92. fi
  93. export AWS_ACCESS_KEY_ID AWS_SECRET_ACCESS_KEY
  94. export AWS_PROFILE=default
  95. mfa_serial_number=$(aws configure get mfa_serial)
  96. if ! mfa=$(zenity --entry --text=MFA 2> /dev/null); then
  97. log "Failed to get MFA"
  98. return 1
  99. fi
  100. if credentials=$(aws sts assume-role --serial-number "$mfa_serial_number" --token-code "$mfa" --role-arn "$role_arn" --role-session-name "$(hostname)" --duration-seconds "$duration"); then
  101. gpg --batch -c --passphrase-file <(echo "$password") <<< "$credentials" > "$cache_gpg"
  102. else
  103. return 1
  104. fi
  105. fi
  106. echo "$credentials"
  107. }
  108. function get_cached_short_term_credentials {
  109. if [ "$use_cache" -eq 0 ]; then
  110. return 1
  111. fi
  112. keyctl pipe "%user:$cache_key" 2>/dev/null
  113. }
  114. function get_short_term_credentials {
  115. if ! credentials=$(get_cached_short_term_credentials); then
  116. if ! role_arn=$(get_role_arn); then
  117. return 1
  118. fi
  119. if ! long_term_credentials="$(get_long_term_credentials 43200)"; then
  120. return 1
  121. fi
  122. AWS_ACCESS_KEY_ID=$(jq -r .Credentials.AccessKeyId <<<"$long_term_credentials")
  123. AWS_SECRET_ACCESS_KEY=$(jq -r .Credentials.SecretAccessKey <<<"$long_term_credentials")
  124. AWS_SESSION_TOKEN=$(jq -r .Credentials.SessionToken <<<"$long_term_credentials")
  125. export AWS_ACCESS_KEY_ID AWS_SECRET_ACCESS_KEY AWS_SESSION_TOKEN
  126. if credentials=$(aws sts assume-role --role-arn "$role_arn" --role-session-name "$(hostname)" --duration-seconds "$duration"); then
  127. keyctl padd user "$cache_key" @s <<<"$credentials" >/dev/null
  128. keyctl timeout "%user:$cache_key" "$duration" >/dev/null
  129. else
  130. return 1
  131. fi
  132. fi
  133. echo "$credentials"
  134. }
  135. while keyctl read '%user:lock' >/dev/null 2>&1; do
  136. sleep 1
  137. done
  138. keyctl add user lock lock @s >/dev/null 2>&1
  139. function finish {
  140. keyctl revoke '%user:lock' 2>&1
  141. }
  142. trap finish EXIT
  143. if [ "$duration" -gt 3600 ]; then
  144. if ! credentials=$(get_long_term_credentials "$duration"); then
  145. exit 1
  146. fi
  147. else
  148. if ! credentials=$(get_short_term_credentials); then
  149. exit 1
  150. fi
  151. fi
  152. if [ "$output" = "credential_process" ]; then
  153. jq '.Credentials | .Version=1' <<< "$credentials"
  154. else
  155. jq <<< "$credentials" -r '.Credentials | @sh "
  156. export AWS_ACCESS_KEY_ID=\(.AccessKeyId)
  157. export AWS_SECRET_ACCESS_KEY=\(.SecretAccessKey)
  158. export AWS_SESSION_TOKEN=\(.SessionToken)"'
  159. fi